# =============================================================================
# Copyright (C) 2016-2022 Blue Brain Project
#
# See top-level LICENSE file for details.
# =============================================================================

# coreneuron-config.cmake - package configuration file

get_filename_component(CONFIG_PATH "${CMAKE_CURRENT_LIST_FILE}" PATH)

set(CORENRN_VERSION_MAJOR 8)
set(CORENRN_VERSION_MINOR 2)
set(CORENRN_VERSION_PATCH 2)
set(CORENRN_ENABLE_GPU OFF)
set(CORENRN_ENABLE_NMODL OFF)
set(CORENRN_ENABLE_REPORTING OFF)
set(CORENEURON_LIB_LINK_FLAGS "-Lx86_64 -lcorenrnmech")

find_path(CORENEURON_INCLUDE_DIR "coreneuron/coreneuron.h" HINTS "${CONFIG_PATH}/../../include")
find_path(
  CORENEURON_LIB_DIR
  NAMES libcoreneuron.a libcoreneuron.so libcoreneuron.dylib
  HINTS "${CONFIG_PATH}/../../lib")

include(${CONFIG_PATH}/coreneuron.cmake)
